/*弹出框使用方法:
 *getMask().maskShow({"speed":100,"filter":0.5,"jump_speed":0.7,"jump_num":0,"width":500,"tit":"弹出框标题","cont":"#cont"});
 *closeMask(); 关闭
 */
var mymask;
/*获取弹出框*/
function getMask(){
	if(mymask==null){mymask = new  Mask();}
	return mymask;
}
/*关闭弹出框*/
function closeMask(){
	$(".clo").click();
}
function Mask(){
	this.wrap = ".maskWrap";//遮罩层总背景
	this.box = ".homepop";//遮罩层
	this.move = ".move";//拖拽
	this.closeBox = ".clo";//关闭
	this.inside = ".inside";//负责存放内容
	this.pm = 5;//拖动层由于父层 padding 、margin 、 position引起的间差,目前设置为手动调节
	this.t = 100;//移动速度
	this.o = 0.5;//遮罩透明度
	this.k = 0.7;//回弹速度
	this.n = 1;//回弹次数
	this.width = 500;//弹出框宽度
	this.tit = "弹出框标题";//标题
	this.cont="#cont";//弹出框div的id
	this.closeCallBack=function(){};//回调函数
}
Mask.prototype = {
	constructor : Mask,
	maskShow : function(){
		if(arguments.length > 0){
			var arr = arguments[0];
			if(arr.pm !== undefined){
				this.pm = arr.pm;
			}
			if(arr.speed !== undefined){
				this.t = arr.speed;
			}
			if(arr.filter !== undefined){
				this.o = arr.filter;
			}
			if(arr.jump_speed !== undefined){
				this.k = arr.jump_speed;
			}
			if(arr.jump_num !== undefined){
				this.n = arr.jump_num;
			}
			if(arr.width !== undefined){
				this.width = arr.width;
			}
			if(arr.tit !== undefined){
				this.tit = arr.tit;
			}
			if(arr.cont !== undefined){
				this.cont = arr.cont;
			}
			if(arr.closeCallBack !== undefined){
				this.closeCallBack = arr.closeCallBack;
			}
		}
		//组建基本的遮罩层
		if($(this.box).html()==null){
			var str = '<div class="maskWrap"></div>';
			str+='<div class="homepop">';
			str+='<div class="move">';
			str+='  <a class="clo">关闭</a>';
			str+='  <span>'+this.tit+'</span>';
			str+='</div>';
			str+='<div class="inside"></div>';
			str+='</div>';
			$("body").prepend(str);
		}else{
			$(this.move+" span").empty();
			$(this.move+" span").html(this.tit);
			$(this.inside).children().hide();
		}
		$(this.inside).append($(this.cont));
		$(this.cont).show();
		var _closeBox  =  $(this.closeBox),
			_wrap  =  $(this.wrap),
			_move  =  $(this.move),
			_box  =  $(this.box),
			_callBack  = this.closeCallBack,
			pm =  this.pm,
			t  =  this.t,
			k  =  this.k,
			o  =  this.o,
			n  =  this.n;
		$(_box).width(this.width);//定义宽度
		var H = $(window).height(),
			W = $("body").width();
		w = _box.width(),
			h = _box.height(),
			v = $("body").height(),
			bH = v - H >= 0 ? v : H;//body高度
		window.onresize = function(){
			H = $(window).height(),
				W = $(window).width(),
				v = $("body").height(),
				bH = v - H >= 0 ? v : H;
		}
		var flag = false,
			time = null,
			zd = {x:0,y:0},
			md = {x:0,y:0};
		_move.mousedown(function(e){
			var p = _move.offset();
			md.x = e.pageX - p.left;
			md.y = e.pageY - p.top;
			flag = true;
		});
		$(document).mousemove(function(e){
			if(flag){
				time = setTimeout(function(){
					z(e.pageX, e.pageY);
				}, 30);
				return false;
			}
		}).mouseup(function(){
			flag = false;
		});
		function z(X, Y){
			zd.x = X - md.x - pm;
			zd.y = Y - md.y - pm;
			if(X - md.x <= 0){
				zd.x = 0
			}
			if(Y - md.y <= 0){
				zd.y = 0
			}
			if(zd.x >= W - w){
				zd.x = W - w
			}
			if(zd.y >= bH - h){
				zd.y = bH - h
			}
			if(X <= 0 || Y <= 0 || X >= W || Y >= bH){
				flag = false;
			}
			_box.css({
				"left": zd.x + 'px',
				"top": zd.y + 'px'
			});
		}
		var cH = H/2 - h/2 + $(window).scrollTop(),
			vh= v - h >= 0 ? v : h,
			num = 1,
			j = 3;
		var tt=vh / 2 - h / 2;
		_wrap.show().css("height", bH + 'px').stop(true, false).animate({
			"opacity": o
		}, t, function(){
			_box.show().css({
				"left": W/2 - w/2 + 'px',
				// "top": -h + 'px'
				"top": -h + 'px'
			}).stop(true, false).animate({
				//  "top": vh/2-h/2 + 'px'
				"top": cH + 'px'
			}, t*k);
			function start(n){
				num *= k;
				j *= 2;
				if(n<=1){
					return false;
				}
				_box.animate({
					"top": cH - h/j + 'px'
				}, t*k*num).animate({
					"top": cH + 'px'
				}, t*k*num);
				arguments.callee(n-1);
			}
			start(n);
		});
		_wrap.clearQueue();
		_closeBox.click(function(){//关闭
			_box.stop(true, false).animate({
				"top": -h + 'px'
			},{
				duration: t*6,
				queue: false
			})
				.delay(t/2, "del")
				.queue("del", function(next){
					$(this).stop(true, false).animate({
						"top": -h + 'px'
					}, t, function(){
						_wrap.animate({
							"opacity": 0
						}, t, function(){
							$(this).hide();
						});
						_box.hide();
					});
					next();
				}).dequeue("del");
			_callBack();
			_box.clearQueue();
			return false;
		});
	}
}